const targz = require("targz");
const ArchiverBase = require("./ArchiverBase");

module.exports=
class TarGZArchiver extends ArchiverBase
{
	/**
	 * constructor
	 */
	constructor()
	{
		super();
	}
	
	/**
	 * @param  {string} strSource
	 * @param  {string} strDestination
	 *
	 * @return {string}
	 */
	async compress(strSource, strDestination)
	{
		let fnResolve;
		let fnReject;

		const promise = new Promise(
			(_fnResolve, _fnReject) => 
			{
				fnResolve = _fnResolve;
				fnReject = _fnReject;
			}
		);

		let options = {
			src: strSource,
			dest: strDestination
		};

		targz.compress(options, (error) =>
		{
			if(error)
			{
				fnReject(error);
			}
			else
			{
				fnResolve();
			}
		});

		return promise;
	}

	
	/**
	 * @param  {string} strSource
	 * @param  {string} strDestination
	 */
	async decompress(strSource, strDestination)
	{
		this.decompressStartedCount++;
		let fnResolve;
		let fnReject;

		const promise = new Promise(
			(_fnResolve, _fnReject) => 
			{
				fnResolve = _fnResolve;
				fnReject = _fnReject;
			}
		);

		let options = {
			src: strSource,
			dest: strDestination
		};

		targz.decompress(options, (error) =>
		{
			if(error)
			{
				fnReject(error);
			}
			else
			{
				this.decompressFinishedCount++;
				fnResolve();
			}
		});

		return promise;
	}
};
