const crypto = require("crypto");
const fs = require("fs");
const path = require("path");
const Glob = require("glob").Glob;

class CRCHash
{
	/**
	 * @param {string} strFolderTree
	 * @returns {Promise}
	 */
	async generate(strFolderTree)
	{
		let fnResolve;
		let fnReject;

		const promise = new Promise((_fnResolve, _fnReject) =>
		{
			fnResolve = _fnResolve;
			fnReject = _fnReject;
		});

		const md5Allsum = crypto.createHash("md5");

		new Glob("**", {dot: true, nodir: true, cwd: strFolderTree}, (error, arrMatches) =>
		{
			if (error)
			{
				fnReject(error);
				return;
			}

			const arrPromises = [];
			try
			{
				arrMatches.forEach((strPath) =>
				{
					const strFullPath = path.join(strFolderTree, strPath);
					arrPromises.push(this.digetstMd5(strFullPath));
				});

				Promise.all(arrPromises)
					.then((arrValues) =>
					{
						arrValues.forEach((strFileDigest) =>
						{
							md5Allsum.update(strFileDigest);
						});
						const strDigetst = md5Allsum.digest("hex");
						fnResolve(strDigetst);
					})
					.catch((error) =>
					{
						fnReject(error);
					});
			}
			catch (error)
			{
				fnReject(error);
			}
		});

		return promise;
	}

	/**
	 * @param md5sum
	 * @param strPath
	 * @returns {Promise}
	 */
	async digetstMd5(strPath)
	{
		const md5Pathsum = crypto.createHash("md5");

		let fnResolve;
		let fnReject;

		const promise = new Promise((_fnResolve, _fnReject) =>
		{
			fnResolve = _fnResolve;
			fnReject = _fnReject;
		});

		const stream = fs.createReadStream(strPath);
		stream.on("data", (strData) =>
		{
			try
			{
				md5Pathsum.update(strData);
			}
			catch (error)
			{
				fnReject(error)
			}
		});
		stream.on("end", function ()
		{
			fnResolve(md5Pathsum.digest("hex"))
		});
		stream.on("error", function (error)
		{
			fnReject(error)
		});

		return promise;
	}
}


module.exports = CRCHash;