#!/bin/bash

# Absolute path to this script.
SCRIPT=$(readlink -f "$0")
SCRIPTPATH=$(dirname "$SCRIPT")
SCRIPTS_FOLDER=$(dirname "$SCRIPTPATH")
WORK_FOLDER=$(dirname "$SCRIPTS_FOLDER")

NODE_EXEC="$WORK_FOLDER/node"
RUNTIME_ARGS="--harmony-async-await"
PROGRAM="$WORK_FOLDER/src/agentHealthUpdateUtility.js"
SERVICE="BSIAgentUtility"
SERVICE_FILE="$SERVICE.service"

chmod +x $NODE_EXEC

rm -rf $WORK_FOLDER/$SERVICE_FILE

echo "[Service]" >> $WORK_FOLDER/$SERVICE_FILE
echo "ExecStart=$NODE_EXEC $PROGRAM" >> $WORK_FOLDER/$SERVICE_FILE
echo "WorkingDirectory=$WORK_FOLDER" >> $WORK_FOLDER/$SERVICE_FILE
echo "Restart=always
StandardOutput=syslog
StandardError=syslog
SyslogIdentifier=BSIAgentUtility
User=root

[Install]
WantedBy=multi-user.target

[Unit]
After=network-online.target
Wants=network-online.target" >> $WORK_FOLDER/$SERVICE_FILE

# Maybe it's ok to call systemctl enable on this file without moving it to /etc/systemd/system/
mv $WORK_FOLDER/$SERVICE_FILE /etc/systemd/system/$SERVICE_FILE

systemctl enable $SERVICE
systemctl start $SERVICE
