// This is only a guideline.
// Please do not asume you can copy as it is and work for any package.

const Publisher = require("../src/Publisher");
const config = require("../src/Config");
const path = require("path");
const fs = require("fs-extra");

/**
 * main function
 */
(
	async () =>
	{
		if(process.cwd().indexOf("tests") > -1)
		{
			process.chdir("..");
		}

		// Create strings with necessary path.
		const publisher = new Publisher();
		const strDownloadFolder = path.join(process.cwd(), "Download");
		const strDecompressOutputFolder = path.join(process.cwd(), "temp");
		let strFileNameList = [];
		for(let item of config.downloadList)
		{
			strFileNameList.push(publisher.getFileNameFromUrl(item));
		}
		const strNodeModulesPath = path.join(process.cwd(), "node_modules");
		const strScriptsPath = path.join(process.cwd(), "src", "scripts");
		const strBsiAgentPackagePath = path.join(process.cwd(), config.strPackageFolderName);
		const strOutputPackageFolderPath = path.join(process.cwd(), "service");
		const strOsList = ["win", "linux", "darwin", "sunos"];

		// Publish.
		await publisher.downloadItems(config.downloadList, strDownloadFolder);
		await publisher.decompress(strFileNameList, strDownloadFolder, strDecompressOutputFolder);
		await publisher.createPackageFolder(
			strBsiAgentPackagePath,
			strNodeModulesPath,
			strScriptsPath
		);

		await publisher.publish(
			strBsiAgentPackagePath, // folder to put to archive.
			strFileNameList, // all versions of node.
			strDecompressOutputFolder, // where to take node exe from.
			strOutputPackageFolderPath, // where to put the final package.
			strOsList);	// subfolder for the package.

		// Cleanup.
		await fs.remove(strDecompressOutputFolder);
		await fs.remove(strBsiAgentPackagePath);
		console.log("Done.");
	}
)();
