const JSONRPC = require("jsonrpc-bidirectional");

class BDKAgent extends JSONRPC.Client
{
	/**
	 * @returns {string}
	 */
	async auth_challenge()
	{
		return this.rpc("auth_challenge", [...arguments]);
	}

	/**
	 * @param {string} strVersion
	 * @param {Object} objServer
	 * @param {string} strChallengeResponse
	 * @param {number} nAgentIDExisting
	 * 
	 * @returns {{agent_id: string, agent_type: string, challenge_response_mutual: string, environment: string, type: string}}
	 */
	async bdk_agent_register(strVersion, objServer, strChallengeResponse, nAgentIDExisting)
	{
		return this.rpc("bdk_agent_register", [...arguments]);
	}

	/**
	 * @param {number} nServerID
	 * @returns {string}
	 */
	async bdk_get_server_status(nServerID)
	{
		return this.rpc("bdk_get_server_status", [...arguments]);
	}

	/**
	 * @returns {null}
	 */
	async keep_alive()
	{
		return this.rpc("keep_alive", [...arguments]);
	}
};

module.exports = BDKAgent;
