const JSONRPC = require("jsonrpc-bidirectional");

class BSIDeployAgent extends JSONRPC.Client
{
	/**
	 * @returns {string}
	 */
	async auth_challenge()
	{
		return this.rpc("auth_challenge", [...arguments]);
	}
	

	/**
	 * @param {string} strVersion
	 * @param {Object} objServer
	 * @param {number} nAgentIDExisting
	 * @param {string} strChallengeResponse
	 *
	 * @returns {{agent_id: string, agent_type: string, datacenter_name: string, challenge_response_mutual: string, environment: string, type: string}}
	 */
	async agent_register(strVersion, objServer, nAgentIDExisting, strChallengeResponse)
	{
		return this.rpc("agent_register", [...arguments]);
	}
	

	/**
	 * @returns {null}
	 */
	async keep_alive()
	{
		return this.rpc("keep_alive", [...arguments]);
	}

	/**
	 * @param {number} nAgentID
	 * @param {OSInfo} osInfo
	 *
	 * @returns {Object}
	 */
	async agent_info_update(nAgentID, osInfo)
	{
		return this.rpc("agent_info_update", [...arguments]);
	}
};

module.exports = BSIDeployAgent;
