const assert = require("assert");

class Lineinfile
{
	/**
	 * Holds informations similar to a Lineinfile module.
	 * 
	 * @param {string} strPath 
	 * @param {string} strLine 
	 * @param {string} strRegexp 
	 */
	constructor(strPath, strLine, strRegexp)
	{
		assert(typeof strPath === "string", "The file to modify must be set.");
		assert(typeof strLine === "string", "The line to insert/replace into the file must be set.");

		this._strPath = strPath;
		this._strLine = strLine;
		this._strRegexp = strRegexp;
	}

	/**
	 * @returns {string}
	 */
	get path()
	{
		return this._strPath;
	}

	/**
	 * @returns {string}
	 */
	get line()
	{
		return this._strLine;
	}

	/**
	 * @returns {string}
	 */
	get regexp()
	{
		return this._strRegexp;
	}
}

module.exports = Lineinfile;
