const NetworkSingleton = require("./Singletons/NetworkSingleton");

class ModuleCallbackRunner
{
	/**
	 * @param {CallbackModule} callback
	 */
	async run(callback)
	{
		let module = null;
		switch (callback.moduleName)
		{
			case "network":
				module = NetworkSingleton;
				break;
			default:
				throw new Error(`Invalid module name: ${callback.moduleName}`);
		}

		const response = await module[callback.moduleFunction].apply(module, callback.params);
		console.log(
			`Ran ${callback.moduleName} ${callback.moduleFunction} with params: ` +
			`[${(() => callback.params.join(", "))()}], and received response: ${response.isChanged()}`
		);
	}
}

module.exports = ModuleCallbackRunner;
