class ModuleError extends Error
{
	/**
	 * @param {string} strMessage
	 * @param {Error} underlyingError
	*/
	constructor(strMessage, underlyingError)
	{
		super(strMessage);
		this._underlyingError = underlyingError || null;
	}

	/**
	 * @returns {*|string}
	*/
	getMessage()
	{
		return this.strMessage;
	}

	/**
	 * @returns {Error|null|*}
	*/
	getUnderliyingError()
	{
		return this._underlyingError;
	}
}

module.exports = ModuleError;
