const BaseTemplate = require("./BaseTemplate");
const assert = require("assert");

class BondFixPreNetworkingScriptTemplate extends BaseTemplate
{
	/**
	 * @param {Object} objVariables
	 */
	validate(objVariables)
	{
		assert(objVariables instanceof Object);
		assert(objVariables.bondName != null);
	}

	async getRenderedTemplate(objVariables)
	{
		return `
#!/bin/bash
if [ ! -d /sys/firmware/ibft ]; then
	modprobe iscsi_ibft
fi

if [ ! -d /sys/firmware/ibft/target0 ]; then
	echo "No target ibft found";
else
	target_ip=$(cat /sys/firmware/ibft/target0/ip-addr)
	nic_assoc=$(cat /sys/firmware/ibft/target0/nic-assoc)
	if [ ! -d /sys/firmware/ibft/ethernet\${nic_assoc} ]; then
		echo "No ethernet ibft found";
	else
		gw=$(cat /sys/firmware/ibft/ethernet\${nic_assoc}/gateway);
		ip route add \${target_ip} via \${gw} dev ${objVariables.bondName};
	fi
fi

exit 0
`;
	}
};

module.exports = BondFixPreNetworkingScriptTemplate;
