const BaseTemplate = require("./BaseTemplate");
const assert = require("assert");

class BondFixPreNetworkingUnitTemplate extends BaseTemplate
{
	/**
	 * @param {Object} objVariables
	 */
	validate(objVariables)
	{
		assert(objVariables instanceof Object);
		assert(objVariables.bondName != null);
	}

	/**
	 * @param {Object} objVariables
	 * @returns {string}
	 */
	async getRenderedTemplate(objVariables)
	{
		return `
[Unit]
Description=Bigstep ${objVariables.bondName} pre networking fix
Before=network-pre.target

[Service]
User=root
Group=root
Type=oneshot
GuessMainPID=no
ExecStart=/usr/sbin/bigstep-${objVariables.bondName}-pre-networking-fix
[Install]
WantedBy=multi-user.target`;
	}
};

module.exports = BondFixPreNetworkingUnitTemplate;
