const assert = require("assert");
const BaseTemplate = require("./BaseTemplate");

class BondFixScriptTemplate extends BaseTemplate
{
	/**
	 * @param {Object} objVariables
	 * @returns {string}
	 */
	getRenderedTemplate(objVariables)
	{
		return `
#!/bin/sh
interface=$1
echo "Bond fix init" >> /var/log/agent-boot
if [ "$interface" = "${objVariables.bondName}" ]; then
	/sbin/ip route delete default dev ${objVariables.bondName}
fi
`;
	}

	/**
	 * @param {Object} objBond
	 */
	validate(objBond)
	{
		assert(objBond instanceof Object);
		assert(objBond.bondName != null);
	}
};

module.exports = BondFixScriptTemplate;
