const BaseTemplate = require("./BaseTemplate");
const assert = require("assert");

class CloudInitScriptTemplate extends BaseTemplate
{
	/**
	 * @param {Object} objVariables
	 * @returns {string}
	 */
	getRenderedTemplate(objVariables)
	{
		return `
chr() 
{
	printf \\$(printf '%03o' $1)
}

RUN="yes"

bigstep_cloudinit_dhcp_hook_config()
{
if [ "$RUN" = "yes" ]; then
	# iBFT default route fix
	case \${interface} in
		ibft0)
			ip r del default dev ibft0
		;;
		${objVariables.bondName})
			ip r del default dev ${objVariables.bondName}
		;;
	esac
		
	if [ -n "$new_filename" ]; then
		mkdir -p /var/lib/cloud/data/seed/bigstep
		echo -n ""  >  /var/lib/cloud/data/seed/bigstep/url
		arr=($new_filename)
		for i in \${arr[@]}; do
			c=\`chr $i\`
			echo -n $c >> /var/lib/cloud/data/seed/bigstep/url
		done
	fi
fi
}

bigstep_cloudinit_dhcp_hook_restore()
{
	return
}
`;
	}
	/**
	 * @param {Object} objBond
	 */
	validate(objBond)
	{
		assert(objBond instanceof Object);
		assert(objBond.bondName != null);
	}
};

module.exports = CloudInitScriptTemplate;
