const BaseTemplate = require("./BaseTemplate");
const assert = require("assert");
const os = require("os");

class DiskPartitionMountTemplate extends BaseTemplate
{
	/**
	 * @param {Object} objVariables
	 */
	validate(objVariables)
	{
		assert(objVariables instanceof Object);
		assert(objVariables.description != null);
		assert(objVariables.diskPath != null);
		assert(objVariables.mountPoint != null);
		assert(objVariables.fileSystem != null);
	}

	async getRenderedTemplate(objVariables)
	{
		return `
[Unit]
Description=${objVariables.description}
ConditionPathExists=${objVariables.diskPath}

[Mount]
What=${objVariables.diskPath}
Where=${objVariables.mountPoint}
Type=${objVariables.fileSystem}
Options=defaults

[Install]
WantedBy=multi-user.target` + os.EOL;
	}
};

module.exports = DiskPartitionMountTemplate;
