const assert = require("assert");
const BaseTemplate = require("./BaseTemplate");
const ISCSIInitiatorName = require("../../Models/ISCSIInitiatorName");

class ISCSIInitiatorNameTemplate extends BaseTemplate
{
	/**
	 * @param {*} ISCSIInitiatorNameModel 
	 * @returns {string}
	 */
	async getRenderedTemplate(ISCSIInitiatorNameModel)
	{
		return `InitiatorName=${ISCSIInitiatorNameModel.ISCSIInitiatorIQN}`;
	}

	/**
	 * @param {Object} ISCSIInitiatorNameModel
	 */
	validate(ISCSIInitiatorNameModel)
	{
		assert(ISCSIInitiatorNameModel instanceof ISCSIInitiatorName);
	}
}

module.exports = ISCSIInitiatorNameTemplate;
