const assert = require("assert");
const BondMaster = require("../../Models/BondMaster");
const BaseTemplate = require("./BaseTemplate");

class IfcfgBondMasterTemplate extends BaseTemplate
{
	/**
	 * @param {Object} objVariables
	 * @returns {string}
	 */
	getRenderedTemplate(objVariables)
	{
		return `
DEVICE=${objVariables.bondName}
NAME=${objVariables.bondName}
BONDING_MASTER=yes
TYPE=Bond
BOOTPROTO=dhcp
ONBOOT=yes
PEERDNS=yes
BONDING_OPTS="mode=4 miimon=100 lacp_rate=1
`;
	}

	/**
	 * @param {Object} bondMaster
	 */
	validate(bondMaster)
	{
		assert(bondMaster instanceof BondMaster);
	}
}

module.exports = IfcfgBondMasterTemplate;
