const assert = require("assert");
const BondSlave = require("../../Models/BondSlave");
const BaseTemplate = require("./BaseTemplate");

class IfcfgBondSlaveTemplate extends BaseTemplate
{
	/**
	 * @param {Object} objVariables
	 * @returns {string}
	 */
	getRenderedTemplate(objVariables)
	{
		return `
DEVICE=${objVariables.name}
NAME=${objVariables.name}
BOOTPROTO=none
ONBOOT=yes
MASTER=${objVariables.masterInterface}
SLAVE=yes
USERCTL=no
`;
	}

	/**
	 * @param {Object} bondSlaveModel
	 */
	validate(bondSlaveModel)
	{
		assert(bondSlaveModel instanceof BondSlave);
	}
}

module.exports = IfcfgBondSlaveTemplate;
