class BasePlay
{
	constructor()
	{
		this._arrSteps = [];
	}

	/**
	 * @param {Callable} fnStep
	 */
	addStep(fnStep)
	{
		this._arrSteps.push(fnStep);
	}

	validateParams()
	{
		throw new Error("This must be implemented");
	}

	/**
	 * @param {Object} objParams
	 *
	 * @returns {boolean}
	 */
	async run(objParams)
	{
		let bIsChanged = false;
		this._objParams = objParams || {};
		this.validateParams();

		for (const fnStep of this._arrSteps)
		{
			try
			{
				const bStepIsChanged = await fnStep();
				bIsChanged = bIsChanged || bStepIsChanged;
			}
			catch (error)
			{
				console.error(error);
				throw error;
			}
		}

		return bIsChanged;
	}
}

module.exports = BasePlay;
