const BasePlay = require("./BasePlay");

const folderSingleton = require("../Modules").FolderSingleton;
const serviceManagerSingleton = require("../Modules").ServiceManagerSingleton;

class SelfResetPlay extends BasePlay
{
	constructor()
	{
		super();
		this.addStep(this.clean.bind(this));
	}

	/**
	 * @throws {Error}
	 */
	async validateParams() 
	{}

	/**
	 * @returns {boolean}
	 */
	async clean()
	{
		let bIsChanged = false;

		const stateDeleteResponse = await folderSingleton.grepDelete("/var/lib/MetalCloudAgent", ".*");
		bIsChanged = bIsChanged || stateDeleteResponse.isChanged();

		const settingsDeletedResponse = await folderSingleton.grepDelete("/etc/BSIDeployAgent/", ".*");
		bIsChanged = bIsChanged || settingsDeletedResponse.isChanged();

		setTimeout(async() => 
		{
			await serviceManagerSingleton.selfStop();
		}, 20000);

		return bIsChanged;
	}
}

module.exports = SelfResetPlay;
