// @ts-check

const CommandBase = require("./CommandBase");

class CCMcfg extends CommandBase
{
	constructor(objConfig = {})
	{
		super(objConfig);
	}

	static get command()
	{
		return `
			/opt/bcm/ccm/ccmcfg -get
			/opt/bcm/ccm/ccmcfg -list
			tail -n +1 *.CFG
		`;
	}

	/**
	 * Parses the raw output from the command, must me runned after execCommand
	 * 
	 * @param {string} [strResult=null]
	 * @returns {Promise<Object>} _objParsedCommandOutput
	 */
	async _parseCommandOutput(strResult = null)
	{
		if(strResult)
		{
			this._strRawCommandOutput = strResult;
		}

		if(!this._strRawCommandOutput || this._strRawCommandOutput.trim() === "")
		{
			throw new Error(`Empty output string for command ${this.constructor.name}.`);
		}

		this._objParsedCommandOutput = {};
		return this._objParsedCommandOutput;
	}

	get parsedOutput()
	{
		return this._objParsedCommandOutput;
	}

	static get osPlatform()
	{
		return "linux";
	}

	async test()
	{

	}
}

module.exports = new CCMcfg({bMustBeFiltered: false, bMustBeParsed: true});
