// @ts-check

const CommandBase = require("./CommandBase");
const Utils = require("jskippy-node").Utils;

class Lshw extends CommandBase
{
	constructor(objConfig = {})
	{
		super(objConfig);

		this._strOSPlatform = "linux";
	}

	/**
	 * Parses the raw output from the command, must me runned after execCommand
	 * 
	 * @param {string} [strResult=null]
	 * @returns {Promise<Object>} _objParsedCommandOutput
	 */
	async _parseCommandOutput(strResult = null)
	{
		if(strResult)
		{
			this._strRawCommandOutput = strResult;
		}

		if(!this._strRawCommandOutput || this._strRawCommandOutput.trim() === "")
		{
			throw new Error(`Empty output string for command ${this.constructor.name}.`);
		}

		this._objParsedCommandOutput = Utils.safeJSONParse(this._strRawCommandOutput);
		return this._objParsedCommandOutput;
	}

	static get command()
	{
		return "/usr/sbin/lshw -json";
	}

	static get osPlatform()
	{
		return "linux";
	}

	get parsedOutput()
	{
		return this._objParsedCommandOutput;
	}

	async test()
	{
		
	}
}

module.exports = new Lshw({bMustBeFiltered: false, bMustBeParsed: true});
