const assert = require("assert");

class NetworkInterface 
{
	/**
	 * @param {string} strName
	 * @param {string} strType
	 * @param {string} strMACAddress
	 */
	constructor(strName, strType, strMACAddress)
	{
		assert(typeof strName === "string", "strAddress variable must be set!");
		assert(typeof strType === "string", "strType variable must be set!");

		this._strName = strName;
		this._strType = strType;
		this._strMACAddress = strMACAddress || null;
	}

	/**
	 * @returns {string}
	 */
	getType()
	{
		return this._strType;
	}

	/**
	 *
	 * @returns {string}
	 */
	getName()
	{
		return this._strName;
	}

	get macAddress()
	{
		return this._strMACAddress;
	}

	set macAddress(strMACAddress)
	{
		this._strMACAddress = strMACAddress;
	}
}

NetworkInterface.TYPE_PHYSICAL = "physical";
NetworkInterface.TYPE_VIRTUAL = "virtual";

module.exports = NetworkInterface;
