const ChildProcess = require("child_process");

class LoggedChildProcess {
	/**
	 * @param {string} strCommand
	 * @param {Object} objOptions
	 * @returns {ChildProcess}
	 */
	spawn(strCommand, objOptions)
	{
		objOptions = objOptions || {};
		objOptions.shell = objOptions.shell || false;
		objOptions.nUserID = objOptions.nUserID || 0;
		objOptions.nGroupID = objOptions.nGroupID || 0;

		const subProcess = ChildProcess.spawn(strCommand, [],
			{
				shell: objOptions.shell,
				uid: objOptions.nUserID,
				git: objOptions.nGroupID
			});

		// make sure data get written to parent stdout && stderr
		subProcess.stdout.pipe(process.stdout);
		subProcess.stderr.pipe(process.stderr);

		return subProcess;
	}
}

module.exports = LoggedChildProcess;
