class BaseMountManager
{
	/**
	 * @returns {boolean}
	 */
	async isUsable()
	{
		throw new Error("Must be implemented");
	}

	/**
	 * @param {string} strMountPoint
	 * @param {string} strDiskPath
	 * @param {string} strFilesystemType
	 */
	async mount(strMountPoint, strDiskPath, strFilesystemType)
	{
		throw new Error("Must be implemented.");
	}

	/**
	 * @param {string} strMountPoint
	 * @param {string} strDiskPath
	 * @param {string} strFilesystemType
	 */
	async isMounted(strMountPoint, strDiskPath, strFilesystemType)
	{
		throw new Error("Must be implemented.");
	}

	/**
	 * @param {string} strMountPoint
	 */
	async unmount(strMountPoint)
	{
		throw new Error("Must be implemented.");
	}

	/**
	 * @param {string} strMountPoint
	 * @param {string} strDiskPath
	 * @param {string} strFilesystemType
	 */
	async mountAndSetAutomount(strMountPoint, strDiskPath, strFilesystemType)
	{
		throw new Error("Must be implemented.");
	}

	/**
	 * @param {string} strMountPoint
	 * @param {string} strDiskPath
	 * @param {string} strFilesystemType
	 */
	async isAutomountSet(strMountPoint, strDiskPath, strFilesystemType)
	{
		throw new Error("Must be implemented.");
	}

	/**
	 * @param {string} strMountPoint
	 */
	async unmountAndUnsetAutomount(strMountPoint)
	{
		throw new Error("Must be implemented.");
	}
}

module.exports = BaseMountManager;
