const SystemdSingleton = require("./SystemdSingleton");

class MountManagerProxy
{
	constructor()
	{
		this._mountManagers = [SystemdSingleton];
		this._usableMountManager = null;
	}

	/**
	 * @returns {BaseSystem}
	 */
	async getUsable()
	{
		if (this._usableMountManager !== null)
		{
			return this._usableMountManager;
		}

		for (const mountManager of this._mountManagers)
		{
			if (await mountManager.isUsable())
			{
				this._usableMountManager = mountManager;
				return this._usableMountManager;
			}
		}

		throw new Error("No mount manager found on this machine!");
	}
}

module.exports = MountManagerProxy;
