var YumSingleton = require("./YUMSingleton");

class PackageManagerProxy
{
	constructor()
	{
		this._packageManagers = [YumSingleton];
	}

	/**
	 * @returns {BaseSystemServices}
	 */
	async getUsable()
	{
		if (this._usableServiceManager !== null)
		{
			return this._usableServiceManager;
		}

		for (const packageManager of this._packageManagers)
		{
			if (await packageManager.isUsable())
			{
				this._usableServiceManager = packageManager;
				return this._usableServiceManager;
			}
		}

		throw new Error("No implemented package manager found on this machine!");
	}
}

module.exports = PackageManagerProxy;
