const AgentHealthUpdate = require("./AgentHealthUpdate");

(
	async() =>
	{
		const nOneMinuteSeconds = 60;
		const nOneMinuteMilliseconds = nOneMinuteSeconds * 1000;
		const nThirtySecondsMilliseconds = 30 * 1000;

		const agentHealthUpdate = new AgentHealthUpdate();
		const strStartTimeUTC = new Date().toUTCString();

		this._nCheckUpdateIntervalID = setInterval(
			async() =>
			{
				try
				{
					await agentHealthUpdate.checkForUpdate();
				}
				catch (error)
				{
					await agentHealthUpdate.logError(error);
				}
			},
			nThirtySecondsMilliseconds
		);

		this._checkSanityIntervalID = setInterval(
			async() =>
			{
				try
				{
					await agentHealthUpdate.checkSanity(strStartTimeUTC);
				}
				catch (error)
				{
					await agentHealthUpdate.logError(error);
				}
			},
			nOneMinuteMilliseconds
		);
	}
)();
